01873d3247a375fb80e6f8fb2c0f45049f33696f
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2021 Cisco and/or its affiliates.
2 # Copyright (c) 2021 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install virtualenv==20.0.20 || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
202     #   The name is chosen to match what ci-management expects.
203     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
204     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
205     # Directories created if not present:
206     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
207     # Functions called:
208     # - die - Print to stderr and exit.
209
210     set -exuo pipefail
211
212     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
213         die "Some error during locating of this source file."
214     }
215     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
216         die "Some error during dirname call."
217     }
218     # Current working directory could be in a different repo, e.g. VPP.
219     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
220     relative_csit_dir=$(git rev-parse --show-toplevel) || {
221         die "Git rev-parse failed."
222     }
223     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
224     popd || die "Popd failed."
225     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
226         die "Readlink failed."
227     }
228     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
229         die "Readlink failed."
230     }
231     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
232         die "Readlink failed."
233     }
234     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
235         die "Readlink failed."
236     }
237     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
238         die "Readlink failed."
239     }
240     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
241         die "Readlink failed."
242     }
243
244     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
245         die "Readlink failed."
246     }
247     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
248     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
249         die "Readlink failed."
250     }
251     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
252     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
253         die "Readlink failed."
254     }
255     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
256 }
257
258
259 function compose_pybot_arguments () {
260
261     # Variables read:
262     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
263     # - DUT - CSIT test/ subdirectory, set while processing tags.
264     # - TAGS - Array variable holding selected tag boolean expressions.
265     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
266     # - TEST_CODE - The test selection string from environment or argument.
267     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
268     # Variables set:
269     # - PYBOT_ARGS - String holding part of all arguments for pybot.
270     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
271
272     set -exuo pipefail
273
274     # No explicit check needed with "set -u".
275     PYBOT_ARGS=("--loglevel" "TRACE")
276     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
277
278     case "${TEST_CODE}" in
279         *"device"*)
280             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
281             ;;
282         *"perf"*)
283             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
284             ;;
285         *)
286             die "Unknown specification: ${TEST_CODE}"
287     esac
288
289     EXPANDED_TAGS=()
290     for tag in "${TAGS[@]}"; do
291         if [[ ${tag} == "!"* ]]; then
292             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
293         else
294             if [[ ${SELECTION_MODE} == "--test" ]]; then
295                 EXPANDED_TAGS+=("--test" "${tag}")
296             else
297                 EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
298             fi
299         fi
300     done
301
302     if [[ ${SELECTION_MODE} == "--test" ]]; then
303         EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
304     fi
305 }
306
307
308 function deactivate_docker_topology () {
309
310     # Deactivate virtual vpp-device topology by removing containers.
311     #
312     # Variables read:
313     # - NODENESS - Node multiplicity of desired testbed.
314     # - FLAVOR - Node flavor string, usually describing the processor.
315
316     set -exuo pipefail
317
318     case_text="${NODENESS}_${FLAVOR}"
319     case "${case_text}" in
320         "1n_skx" | "1n_tx2")
321             ssh="ssh root@172.17.0.1 -p 6022"
322             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
323             # The "declare -f" output is long and boring.
324             set +x
325             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
326                 die "Topology cleanup via shim-dcr failed!"
327             }
328             set -x
329             ;;
330         "1n_vbox")
331             enter_mutex || die
332             clean_environment || {
333                 die "Topology cleanup locally failed!"
334             }
335             exit_mutex || die
336             ;;
337         *)
338             die "Unknown specification: ${case_text}!"
339     esac
340 }
341
342
343 function die () {
344
345     # Print the message to standard error end exit with error code specified
346     # by the second argument.
347     #
348     # Hardcoded values:
349     # - The default error message.
350     # Arguments:
351     # - ${1} - The whole error message, be sure to quote. Optional
352     # - ${2} - the code to exit with, default: 1.
353
354     set -x
355     set +eu
356     warn "${1:-Unspecified run-time error occurred!}"
357     exit "${2:-1}"
358 }
359
360
361 function die_on_pybot_error () {
362
363     # Source this fragment if you want to abort on any failed test case.
364     #
365     # Variables read:
366     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
367     # Functions called:
368     # - die - Print to stderr and exit.
369
370     set -exuo pipefail
371
372     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
373         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
374     fi
375 }
376
377
378 function generate_tests () {
379
380     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
381     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
382     # The generation is done by executing any *.py executable
383     # within any subdirectory after copying.
384
385     # This is a separate function, because this code is called
386     # both by autogen checker and entries calling run_pybot.
387
388     # Directories read:
389     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
390     # Directories replaced:
391     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
392
393     set -exuo pipefail
394
395     rm -rf "${GENERATED_DIR}/tests" || die
396     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
397     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
398     cmd_line+=("-executable" "-name" "*.py")
399     # We sort the directories, so log output can be compared between runs.
400     file_list=$("${cmd_line[@]}" | sort) || die
401
402     for gen in ${file_list}; do
403         directory="$(dirname "${gen}")" || die
404         filename="$(basename "${gen}")" || die
405         pushd "${directory}" || die
406         ./"${filename}" || die
407         popd || die
408     done
409 }
410
411
412 function get_test_code () {
413
414     # Arguments:
415     # - ${1} - Optional, argument of entry script (or empty as unset).
416     #   Test code value to override job name from environment.
417     # Variables read:
418     # - JOB_NAME - String affecting test selection, default if not argument.
419     # Variables set:
420     # - TEST_CODE - The test selection string from environment or argument.
421     # - NODENESS - Node multiplicity of desired testbed.
422     # - FLAVOR - Node flavor string, usually describing the processor.
423
424     set -exuo pipefail
425
426     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
427     if [[ -z "${TEST_CODE}" ]]; then
428         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
429     fi
430
431     case "${TEST_CODE}" in
432         *"1n-vbox"*)
433             NODENESS="1n"
434             FLAVOR="vbox"
435             ;;
436         *"1n-skx"*)
437             NODENESS="1n"
438             FLAVOR="skx"
439             ;;
440        *"1n-tx2"*)
441             NODENESS="1n"
442             FLAVOR="tx2"
443             ;;
444         *"2n-aws"*)
445             NODENESS="2n"
446             FLAVOR="aws"
447             ;;
448         *"3n-aws"*)
449             NODENESS="3n"
450             FLAVOR="aws"
451             ;;
452         *"2n-skx"*)
453             NODENESS="2n"
454             FLAVOR="skx"
455             ;;
456         *"2n-zn2"*)
457             NODENESS="2n"
458             FLAVOR="zn2"
459             ;;
460         *"3n-skx"*)
461             NODENESS="3n"
462             FLAVOR="skx"
463             ;;
464         *"2n-clx"*)
465             NODENESS="2n"
466             FLAVOR="clx"
467             ;;
468         *"2n-dnv"*)
469             NODENESS="2n"
470             FLAVOR="dnv"
471             ;;
472         *"3n-dnv"*)
473             NODENESS="3n"
474             FLAVOR="dnv"
475             ;;
476         *"2n-tx2"*)
477             NODENESS="2n"
478             FLAVOR="tx2"
479             ;;
480         *"3n-tsh"*)
481             NODENESS="3n"
482             FLAVOR="tsh"
483             ;;
484     esac
485 }
486
487
488 function get_test_tag_string () {
489
490     # Variables read:
491     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
492     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
493     # - TEST_CODE - The test selection string from environment or argument.
494     # Variables set:
495     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
496     #   May be empty, or even not set on event types not adding comment.
497
498     # TODO: ci-management scripts no longer need to perform this.
499
500     set -exuo pipefail
501
502     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
503         case "${TEST_CODE}" in
504             *"device"*)
505                 trigger="devicetest"
506                 ;;
507             *"perf"*)
508                 trigger="perftest"
509                 ;;
510             *)
511                 die "Unknown specification: ${TEST_CODE}"
512         esac
513         # Ignore lines not containing the trigger word.
514         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
515         # The vpp-csit triggers trail stuff we are not interested in.
516         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
517         # (except relying on \s whitespace, \S non-whitespace and . both).
518         # The last string is concatenated, only the middle part is expanded.
519         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
520         # On parsing error, TEST_TAG_STRING probably stays empty.
521         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
522         if [[ -z "${TEST_TAG_STRING-}" ]]; then
523             # Probably we got a base64 encoded comment.
524             comment="${GERRIT_EVENT_COMMENT_TEXT}"
525             comment=$(base64 --decode <<< "${comment}" || true)
526             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
527             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
528         fi
529         if [[ -n "${TEST_TAG_STRING-}" ]]; then
530             test_tag_array=(${TEST_TAG_STRING})
531             if [[ "${test_tag_array[0]}" == "icl" ]]; then
532                 export GRAPH_NODE_VARIANT="icl"
533                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
534             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
535                 export GRAPH_NODE_VARIANT="skx"
536                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
537             fi
538         fi
539     fi
540 }
541
542
543 function installed () {
544
545     # Check if the given utility is installed. Fail if not installed.
546     #
547     # Duplicate of common.sh function, as this file is also used standalone.
548     #
549     # Arguments:
550     # - ${1} - Utility to check.
551     # Returns:
552     # - 0 - If command is installed.
553     # - 1 - If command is not installed.
554
555     set -exuo pipefail
556
557     command -v "${1}"
558 }
559
560
561 function move_archives () {
562
563     # Move archive directory to top of workspace, if not already there.
564     #
565     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
566     # but in some jobs CSIT_DIR is not same as WORKSPACE
567     # (e.g. under VPP_DIR). To simplify ci-management settings,
568     # we want to move the data to the top. We do not want simple copy,
569     # as ci-management is eager with recursive search.
570     #
571     # As some scripts may call this function multiple times,
572     # the actual implementation use copying and deletion,
573     # so the workspace gets "union" of contents (except overwrites on conflict).
574     # The consequence is empty ARCHIVE_DIR remaining after this call.
575     #
576     # As the source directory is emptied,
577     # the check for dirs being different is essential.
578     #
579     # Variables read:
580     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
581     #   Can be unset, then it speeds up manual testing.
582     # - ARCHIVE_DIR - Path to directory with content to be moved.
583     # Directories updated:
584     # - ${WORKSPACE}/archives/ - Created if does not exist.
585     #   Content of ${ARCHIVE_DIR}/ is moved.
586     # Functions called:
587     # - die - Print to stderr and exit.
588
589     set -exuo pipefail
590
591     if [[ -n "${WORKSPACE-}" ]]; then
592         target=$(readlink -f "${WORKSPACE}/archives")
593         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
594             mkdir -p "${target}" || die "Archives dir create failed."
595             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
596             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
597         fi
598     fi
599 }
600
601
602 function prepare_topology () {
603
604     # Prepare virtual testbed topology if needed based on flavor.
605
606     # Variables read:
607     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
608     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
609     # Functions called:
610     # - die - Print to stderr and exit.
611     # - terraform_init - Terraform init topology.
612     # - terraform_apply - Terraform apply topology.
613
614     set -exuo pipefail
615
616     case_text="${NODENESS}_${FLAVOR}"
617     case "${case_text}" in
618         "2n_aws")
619             terraform_init || die "Failed to call terraform init."
620             terraform_apply || die "Failed to call terraform apply."
621             ;;
622         "3n_aws")
623             terraform_init || die "Failed to call terraform init."
624             terraform_apply || die "Failed to call terraform apply."
625             ;;
626     esac
627 }
628
629
630 function reserve_and_cleanup_testbed () {
631
632     # Reserve physical testbed, perform cleanup, register trap to unreserve.
633     # When cleanup fails, remove from topologies and keep retrying
634     # until all topologies are removed.
635     #
636     # Variables read:
637     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
638     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
639     # - BUILD_TAG - Any string suitable as filename, identifying
640     #   test run executing this function. May be unset.
641     # Variables set:
642     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
643     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
644     # Functions called:
645     # - die - Print to stderr and exit.
646     # - ansible_playbook - Perform an action using ansible, see ansible.sh
647     # Traps registered:
648     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
649
650     set -exuo pipefail
651
652     while true; do
653         for topo in "${TOPOLOGIES[@]}"; do
654             set +e
655             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
656             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
657             python3 "${scrpt}" "${opts[@]}"
658             result="$?"
659             set -e
660             if [[ "${result}" == "0" ]]; then
661                 # Trap unreservation before cleanup check,
662                 # so multiple jobs showing failed cleanup improve chances
663                 # of humans to notice and fix.
664                 WORKING_TOPOLOGY="${topo}"
665                 echo "Reserved: ${WORKING_TOPOLOGY}"
666                 trap "untrap_and_unreserve_testbed" EXIT || {
667                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
668                     untrap_and_unreserve_testbed "${message}" || {
669                         die "Teardown should have died, not failed."
670                     }
671                     die "Trap attempt failed, unreserve succeeded. Aborting."
672                 }
673                 # Cleanup + calibration checks
674                 set +e
675                 ansible_playbook "cleanup, calibration"
676                 result="$?"
677                 set -e
678                 if [[ "${result}" == "0" ]]; then
679                     break
680                 fi
681                 warn "Testbed cleanup failed: ${topo}"
682                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
683             fi
684             # Else testbed is accessible but currently reserved, moving on.
685         done
686
687         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
688             # Exit the infinite while loop if we made a reservation.
689             warn "Reservation and cleanup successful."
690             break
691         fi
692
693         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
694             die "Run out of operational testbeds!"
695         fi
696
697         # Wait ~3minutes before next try.
698         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
699             die "Sleep time calculation failed."
700         }
701         echo "Sleeping ${sleep_time}"
702         sleep "${sleep_time}" || die "Sleep failed."
703     done
704 }
705
706
707 function run_pybot () {
708
709     # Run pybot with options based on input variables. Create output_info.xml
710     #
711     # Variables read:
712     # - CSIT_DIR - Path to existing root of local CSIT git repository.
713     # - ARCHIVE_DIR - Path to store robot result files in.
714     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
715     # - GENERATED_DIR - Tests are assumed to be generated under there.
716     # Variables set:
717     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
718     # Functions called:
719     # - die - Print to stderr and exit.
720
721     set -exuo pipefail
722
723     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
724     all_options+=("--noncritical" "EXPECTED_FAILING")
725     all_options+=("${EXPANDED_TAGS[@]}")
726
727     pushd "${CSIT_DIR}" || die "Change directory operation failed."
728     set +e
729     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
730     PYBOT_EXIT_STATUS="$?"
731     set -e
732
733     # Generate INFO level output_info.xml for post-processing.
734     all_options=("--loglevel" "INFO")
735     all_options+=("--log" "none")
736     all_options+=("--report" "none")
737     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
738     all_options+=("${ARCHIVE_DIR}/output.xml")
739     rebot "${all_options[@]}" || true
740     popd || die "Change directory operation failed."
741 }
742
743
744 function select_arch_os () {
745
746     # Set variables affected by local CPU architecture and operating system.
747     #
748     # Variables set:
749     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
750     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
751     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
752
753     set -exuo pipefail
754
755     source /etc/os-release || die "Get OS release failed."
756
757     case "${ID}" in
758         "ubuntu"*)
759             case "${VERSION}" in
760                 *"LTS (Focal Fossa)"*)
761                     IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
762                     VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_FOCAL"
763                     PKG_SUFFIX="deb"
764                     ;;
765                 *)
766                     die "Unsupported Ubuntu version!"
767                     ;;
768             esac
769             ;;
770         *)
771             die "Unsupported distro or OS!"
772             ;;
773     esac
774
775     arch=$(uname -m) || {
776         die "Get CPU architecture failed."
777     }
778
779     case "${arch}" in
780         "aarch64")
781             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
782             ;;
783         *)
784             ;;
785     esac
786 }
787
788
789 function select_tags () {
790
791     # Variables read:
792     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
793     # - TEST_CODE - String affecting test selection, usually jenkins job name.
794     # - DUT - CSIT test/ subdirectory, set while processing tags.
795     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
796     #   Can be unset.
797     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
798     # - BASH_FUNCTION_DIR - Directory with input files to process.
799     # Variables set:
800     # - TAGS - Array of processed tag boolean expressions.
801     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
802
803     set -exuo pipefail
804
805     # NIC SELECTION
806     start_pattern='^  TG:'
807     end_pattern='^ \? \?[A-Za-z0-9]\+:'
808     # Remove the TG section from topology file
809     sed_command="/${start_pattern}/,/${end_pattern}/d"
810     # All topologies DUT NICs
811     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
812                 | grep -hoP "model: \K.*" | sort -u)
813     # Selected topology DUT NICs
814     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
815                | grep -hoP "model: \K.*" | sort -u)
816     # All topologies DUT NICs - Selected topology DUT NICs
817     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
818         die "Computation of excluded NICs failed."
819     }
820
821     # Select default NIC tag.
822     case "${TEST_CODE}" in
823         *"3n-dnv"* | *"2n-dnv"*)
824             default_nic="nic_intel-x553"
825             ;;
826         *"3n-tsh"*)
827             default_nic="nic_intel-x520-da2"
828             ;;
829         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
830             default_nic="nic_intel-xxv710"
831             ;;
832         *"2n-tx2"* | *"mrr-daily-master")
833             default_nic="nic_intel-xl710"
834             ;;
835         *"2n-aws"* | *"3n-aws"*)
836             default_nic="nic_amazon-nitro-50g"
837             ;;
838         *)
839             default_nic="nic_intel-x710"
840             ;;
841     esac
842
843     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
844     awk_nics_sub_cmd=""
845     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
846     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
847     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
848     awk_nics_sub_cmd+='gsub("x520-da2","10ge2p1x520");'
849     awk_nics_sub_cmd+='gsub("x553","10ge2p1x553");'
850     awk_nics_sub_cmd+='gsub("cx556a","100ge2p1cx556a");'
851     awk_nics_sub_cmd+='gsub("e810cq","100ge2p1e810cq");'
852     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
853     awk_nics_sub_cmd+='gsub("vic1385","40ge2p1vic1385");'
854     awk_nics_sub_cmd+='gsub("nitro-50g","50ge1p1ENA");'
855     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
856     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
857     awk_nics_sub_cmd+='else if ($9 =="drv_af_xdp") drv ="af-xdp-";'
858     awk_nics_sub_cmd+='else drv="";'
859     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-"$1"-" drv $11"-"$5'
860
861     # Tag file directory shorthand.
862     tfd="${JOB_SPECS_DIR}"
863     case "${TEST_CODE}" in
864         # Select specific performance tests based on jenkins job type variable.
865         *"ndrpdr-weekly"* )
866             readarray -t test_tag_array <<< $(grep -v "#" \
867                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
868                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
869             SELECTION_MODE="--test"
870             ;;
871         *"mrr-daily"* )
872             readarray -t test_tag_array <<< $(grep -v "#" \
873                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
874                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
875             SELECTION_MODE="--test"
876             ;;
877         *"mrr-weekly"* )
878             readarray -t test_tag_array <<< $(grep -v "#" \
879                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
880                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
881             SELECTION_MODE="--test"
882             ;;
883         *"report-iterative"* )
884             test_sets=(${TEST_TAG_STRING//:/ })
885             # Run only one test set per run
886             report_file=${test_sets[0]}.md
887             readarray -t test_tag_array <<< $(grep -v "#" \
888                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
889                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
890             SELECTION_MODE="--test"
891             ;;
892         *"report-coverage"* )
893             test_sets=(${TEST_TAG_STRING//:/ })
894             # Run only one test set per run
895             report_file=${test_sets[0]}.md
896             readarray -t test_tag_array <<< $(grep -v "#" \
897                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
898                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
899             SELECTION_MODE="--test"
900             ;;
901         * )
902             if [[ -z "${TEST_TAG_STRING-}" ]]; then
903                 # If nothing is specified, we will run pre-selected tests by
904                 # following tags.
905                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDethip4-ip4base"
906                                 "mrrAND${default_nic}AND1cAND78bANDethip6-ip6base"
907                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2bdbasemaclrn"
908                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2xcbase"
909                                 "!drv_af_xdp" "!drv_avf")
910             else
911                 # If trigger contains tags, split them into array.
912                 test_tag_array=(${TEST_TAG_STRING//:/ })
913             fi
914             SELECTION_MODE="--include"
915             ;;
916     esac
917
918     # Blacklisting certain tags per topology.
919     #
920     # Reasons for blacklisting:
921     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
922     case "${TEST_CODE}" in
923         *"2n-skx"*)
924             test_tag_array+=("!ipsechw")
925             ;;
926         *"3n-skx"*)
927             test_tag_array+=("!ipsechw")
928             # Not enough nic_intel-xxv710 to support double link tests.
929             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
930             ;;
931         *"2n-clx"*)
932             test_tag_array+=("!ipsechw")
933             ;;
934         *"2n-zn2"*)
935             test_tag_array+=("!ipsechw")
936             ;;
937         *"2n-dnv"*)
938             test_tag_array+=("!ipsechw")
939             test_tag_array+=("!memif")
940             test_tag_array+=("!srv6_proxy")
941             test_tag_array+=("!vhost")
942             test_tag_array+=("!vts")
943             test_tag_array+=("!drv_avf")
944             ;;
945         *"2n-tx2"*)
946             test_tag_array+=("!ipsechw")
947             ;;
948         *"3n-dnv"*)
949             test_tag_array+=("!memif")
950             test_tag_array+=("!srv6_proxy")
951             test_tag_array+=("!vhost")
952             test_tag_array+=("!vts")
953             test_tag_array+=("!drv_avf")
954             ;;
955         *"3n-tsh"*)
956             # 3n-tsh only has x520 NICs which don't work with AVF
957             test_tag_array+=("!drv_avf")
958             test_tag_array+=("!ipsechw")
959             ;;
960         *"2n-aws"* | *"3n-aws"*)
961             test_tag_array+=("!ipsechw")
962             ;;
963     esac
964
965     # We will add excluded NICs.
966     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
967
968     TAGS=()
969     prefix=""
970
971     set +x
972     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
973         # Automatic prefixing for VPP jobs to limit the NIC used and
974         # traffic evaluation to MRR.
975         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
976             prefix="${prefix}mrrAND"
977         else
978             prefix="${prefix}mrrAND${default_nic}AND"
979         fi
980     fi
981     for tag in "${test_tag_array[@]}"; do
982         if [[ "${tag}" == "!"* ]]; then
983             # Exclude tags are not prefixed.
984             TAGS+=("${tag}")
985         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
986             # Badly formed tag expressions can trigger way too much tests.
987             set -x
988             warn "The following tag expression hints at bad trigger: ${tag}"
989             warn "Possible cause: Multiple triggers in a single comment."
990             die "Aborting to avoid triggering too many tests."
991         elif [[ "${tag}" == *"OR"* ]]; then
992             # If OR had higher precedence than AND, it would be useful here.
993             # Some people think it does, thus triggering way too much tests.
994             set -x
995             warn "The following tag expression hints at bad trigger: ${tag}"
996             warn "Operator OR has lower precedence than AND. Use space instead."
997             die "Aborting to avoid triggering too many tests."
998         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
999             # Empty and comment lines are skipped.
1000             # Other lines are normal tags, they are to be prefixed.
1001             TAGS+=("${prefix}${tag}")
1002         fi
1003     done
1004     set -x
1005 }
1006
1007
1008 function select_topology () {
1009
1010     # Variables read:
1011     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
1012     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
1013     # - CSIT_DIR - Path to existing root of local CSIT git repository.
1014     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
1015     # Variables set:
1016     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
1017     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
1018     # Functions called:
1019     # - die - Print to stderr and exit.
1020
1021     set -exuo pipefail
1022
1023     case_text="${NODENESS}_${FLAVOR}"
1024     case "${case_text}" in
1025         "1n_vbox")
1026             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1027             TOPOLOGIES_TAGS="2_node_single_link_topo"
1028             ;;
1029         "1n_skx" | "1n_tx2")
1030             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1031             TOPOLOGIES_TAGS="2_node_single_link_topo"
1032             ;;
1033         "2n_skx")
1034             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
1035             TOPOLOGIES_TAGS="2_node_*_link_topo"
1036             ;;
1037         "2n_zn2")
1038             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
1039             TOPOLOGIES_TAGS="2_node_*_link_topo"
1040             ;;
1041         "3n_skx")
1042             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
1043             TOPOLOGIES_TAGS="3_node_*_link_topo"
1044             ;;
1045         "2n_clx")
1046             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
1047             TOPOLOGIES_TAGS="2_node_*_link_topo"
1048             ;;
1049         "2n_dnv")
1050             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
1051             TOPOLOGIES_TAGS="2_node_single_link_topo"
1052             ;;
1053         "3n_dnv")
1054             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
1055             TOPOLOGIES_TAGS="3_node_single_link_topo"
1056             ;;
1057         "3n_tsh")
1058             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1059             TOPOLOGIES_TAGS="3_node_single_link_topo"
1060             ;;
1061         "2n_tx2")
1062             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_tx2*.yaml )
1063             TOPOLOGIES_TAGS="2_node_single_link_topo"
1064             ;;
1065         "2n_aws")
1066             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_aws*.yaml )
1067             TOPOLOGIES_TAGS="2_node_single_link_topo"
1068             ;;
1069         "3n_aws")
1070             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_aws*.yaml )
1071             TOPOLOGIES_TAGS="3_node_single_link_topo"
1072             ;;
1073         *)
1074             # No falling back to default, that should have been done
1075             # by the function which has set NODENESS and FLAVOR.
1076             die "Unknown specification: ${case_text}"
1077     esac
1078
1079     if [[ -z "${TOPOLOGIES-}" ]]; then
1080         die "No applicable topology found!"
1081     fi
1082 }
1083
1084
1085 function select_vpp_device_tags () {
1086
1087     # Variables read:
1088     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1089     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
1090     #   Can be unset.
1091     # Variables set:
1092     # - TAGS - Array of processed tag boolean expressions.
1093
1094     set -exuo pipefail
1095
1096     case "${TEST_CODE}" in
1097         # Select specific device tests based on jenkins job type variable.
1098         * )
1099             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1100                 # If nothing is specified, we will run pre-selected tests by
1101                 # following tags. Items of array will be concatenated by OR
1102                 # in Robot Framework.
1103                 test_tag_array=()
1104             else
1105                 # If trigger contains tags, split them into array.
1106                 test_tag_array=(${TEST_TAG_STRING//:/ })
1107             fi
1108             SELECTION_MODE="--include"
1109             ;;
1110     esac
1111
1112     # Blacklisting certain tags per topology.
1113     #
1114     # Reasons for blacklisting:
1115     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1116     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1117     case "${TEST_CODE}" in
1118         *"1n-vbox"*)
1119             test_tag_array+=("!avf")
1120             test_tag_array+=("!vhost")
1121             ;;
1122         *)
1123             ;;
1124     esac
1125
1126     TAGS=()
1127
1128     # We will prefix with devicetest to prevent running other tests
1129     # (e.g. Functional).
1130     prefix="devicetestAND"
1131     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1132         # Automatic prefixing for VPP jobs to limit testing.
1133         prefix="${prefix}"
1134     fi
1135     for tag in "${test_tag_array[@]}"; do
1136         if [[ ${tag} == "!"* ]]; then
1137             # Exclude tags are not prefixed.
1138             TAGS+=("${tag}")
1139         else
1140             TAGS+=("${prefix}${tag}")
1141         fi
1142     done
1143 }
1144
1145
1146 function set_environment_variables () {
1147
1148     # Depending on testbed topology, overwrite defaults set in the
1149     # resources/libraries/python/Constants.py file
1150     #
1151     # Variables read:
1152     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1153     # Variables set:
1154     # See specific cases
1155
1156     set -exuo pipefail
1157
1158     case "${TEST_CODE}" in
1159         *"2n-aws"* | *"3n-aws"*)
1160             # T-Rex 2.88 workaround for ENA NICs
1161             export TREX_RX_DESCRIPTORS_COUNT=1024
1162             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1163             # Settings to prevent duration stretching
1164             export PERF_TRIAL_STL_DELAY=0.1
1165             ;;
1166     esac
1167 }
1168
1169
1170 function untrap_and_unreserve_testbed () {
1171
1172     # Use this as a trap function to ensure testbed does not remain reserved.
1173     # Perhaps call directly before script exit, to free testbed for other jobs.
1174     # This function is smart enough to avoid multiple unreservations (so safe).
1175     # Topo cleanup is executed (call it best practice), ignoring failures.
1176     #
1177     # Hardcoded values:
1178     # - default message to die with if testbed might remain reserved.
1179     # Arguments:
1180     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1181     # Variables read (by inner function):
1182     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1183     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1184     # Variables written:
1185     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1186     # Trap unregistered:
1187     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1188     # Functions called:
1189     # - die - Print to stderr and exit.
1190     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1191
1192     set -xo pipefail
1193     set +eu  # We do not want to exit early in a "teardown" function.
1194     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1195     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1196     if [[ -z "${wt-}" ]]; then
1197         set -eu
1198         warn "Testbed looks unreserved already. Trap removal failed before?"
1199     else
1200         ansible_playbook "cleanup" || true
1201         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1202             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1203         }
1204         case "${TEST_CODE}" in
1205             *"2n-aws"* | *"3n-aws"*)
1206                 terraform_destroy || die "Failed to call terraform destroy."
1207                 ;;
1208             *)
1209                 ;;
1210         esac
1211         WORKING_TOPOLOGY=""
1212         set -eu
1213     fi
1214 }
1215
1216
1217 function warn () {
1218
1219     # Print the message to standard error.
1220     #
1221     # Arguments:
1222     # - ${@} - The text of the message.
1223
1224     set -exuo pipefail
1225
1226     echo "$@" >&2
1227 }